// ODBPP Example.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <Windows.h>
#include <iostream>
#include "ODBPP.h"

using namespace std;

CODBPP::Segment index1Segments[] = { {0,(CODBPP::Mode)(CODBPP::TOKEN_FIELD|CODBPP::ALPHANUMERIC_ONLY)}};
CODBPP::Index indexes[] = { {0,CODBPP::W_LIST,1,0,index1Segments} };
CODBPP::Field fields[] = { {CODBPP::USTR,0,64,0,u"Value"} };
CODBPP::Schema tableSchema = { 0,1,1,1,1,0,u"Table",NULL,fields,indexes };

int wmain(int argc, wchar_t* argv[])
{
    __int64 res;
    CODBPP database;
    CODBPP::Object object;
    wchar_t command[_MAX_PATH], * parameter;
    const wchar_t *wp;
    parameter = wcsrchr(argv[0], L'\\'); *parameter = L'\0';
    parameter = wcsrchr(argv[0], L'\\'); *parameter = L'\0';
    for (parameter = wcsrchr(argv[0], L'\\') + 1, wp = TEXT("Database\\Control"); *wp != L'\0'; *(parameter++) = *(wp++)); *parameter = u'\0';
    if ((res = database.OpenDatabase((char16_t*)argv[0])) && ((res & 0xfffff) == ERROR_FILE_NOT_FOUND || (res & 0xfffff) == ERROR_PATH_NOT_FOUND)) {
        if ((res = database.CreateDatabase((char16_t*)argv[0])) == NO_ERROR) {
            if ((res = database.BeginTransaction(CODBPP::EXCLUSIVE)) == NO_ERROR) {
                if ((res = database.CreateTable(&tableSchema))) {
                    database.GetErrorMessage((const char16_t**)&wp);
                    wcout << TEXT("Unable to create table on ") << argv[0] << endl << wp << endl;
                    return 1;
                }
                database.EndTransaction();
            }
            else {
                database.GetErrorMessage((const char16_t**)&wp);
                wcout << TEXT("Unable to begin exclusive transaction on ") << argv[0] << endl << wp << endl;
                return 2;
            }
        }
        else {
            database.GetErrorMessage((const char16_t**)&wp);
            wcout << TEXT("Unable to create database on ") << argv[0] << endl << wp << endl;
            return 3;
        }
    }
    else if(res != NO_ERROR){
        database.GetErrorMessage((const char16_t**)&wp);
        wcout << TEXT("Unable to open database on ") << argv[0] << endl << wp << endl;
        return 4;
    }
    if ((res = database.BeginTransaction()) == NO_ERROR) {
        if ((res = database.OpenTable(tableSchema.tableID)) == NO_ERROR) {
            wcout << TEXT("add <string>; find <string>; delete <objectID>; <any other input to exit>\n");
            while (true) {
                wcin.getline(command, _countof(command));
                for (parameter = command; *parameter != L'\0' && !iswspace(*parameter); parameter++); *(parameter++) = L'\0';
                if (_wcsicmp(command, TEXT("add")) == 0) {
                    if ((res = database.NewObject(tableSchema.tableID, &object, (unsigned int)wcslen(parameter) << 1)) == NO_ERROR) {
                        wcscpy_s((wchar_t*)object.variable, (object.length - (object.variable - object.fixed)) >> 1, parameter);
                        if ((res = database.AddObject(tableSchema.tableID, &object)) == NO_ERROR) {
                            if ((res = database.CommitTransaction())) {
                                database.GetErrorMessage((const char16_t**)&wp);
                                wcout << TEXT("Unable to commit transaction ") << endl << wp << endl;
                            }
                            else wcout << TEXT("Successfully added object into database with id ") << object.ID << endl;
                        }
                        else{
                            database.GetErrorMessage((const char16_t**)&wp);
                            wcout << TEXT("Unable to add object") << endl << wp << endl;
                        }
                    }
                    else {
                        database.GetErrorMessage((const char16_t**)&wp);
                        wcout << TEXT("Unable to new object") << endl << wp << endl;
                    }
                }
                else if (_wcsicmp(command, TEXT("find")) == 0) {
                    if ((res = database.SearchIndex(tableSchema.tableID, 1, NULL, parameter)) == NO_ERROR) {
                        if((res = database.ReadObject(tableSchema.tableID, (CODBPP::Mode)(CODBPP::FIRST | CODBPP::NO_LOCK), &object, 1)))
                            wcout << TEXT("No matching results found") << endl;
                        while (res == NO_ERROR) {
                            wcout << TEXT("Object ") << object.ID << TEXT(": ") << (wchar_t*)object.variable << endl;
                            res = database.ReadObject(tableSchema.tableID, (CODBPP::Mode)(CODBPP::NEXT | CODBPP::NO_LOCK), &object, 1);
                        }
                        if ((res & 0xfffff) != CODBPP::NOT_FOUND_INDEX_KEY) {
                            database.GetErrorMessage((const char16_t**)&wp);
                            wcout << TEXT("error reading object ") << endl << wp << endl;
                        }
                    }
                    else {
                        database.GetErrorMessage((const char16_t**)&wp);
                        wcout << TEXT("Unable to search database index") << endl << wp << endl;
                    }
                }
                else if (_wcsicmp(command, TEXT("delete")) == 0) {
                    if ((res = database.DeleteObject(tableSchema.tableID, _wtoi(parameter))) == NO_ERROR) {
                        if ((res = database.CommitTransaction())) {
                            database.GetErrorMessage((const char16_t**)&wp);
                            wcout << TEXT("Unable to commit transaction ") << endl << wp << endl;
                        }
                        else wcout << TEXT("Successfully deleted object ID = ") << parameter << endl;
                    }
                    else {
                        database.GetErrorMessage((const char16_t**)&wp);
                        wcout << TEXT("Unable to delete object") << endl << wp << endl;
                    }
                }
                else break;
            }
        }
        else {
            database.GetErrorMessage((const char16_t**)&wp);
            wcout << TEXT("Unable to open table on ") << argv[0] << endl << wp << endl;
        }
    }
    else {
        database.GetErrorMessage((const char16_t**)&wp);
        wcout << TEXT("Unable to begin transaction on ") << argv[0] << endl << wp << endl;
    }
}
